给定正整数,判断是否为三个数中的中位数(即从小到大排序后是第二个,不是平均数)。
如果是三个数中的中位数,输出Yes
;否则,输出No
。
输出 | |||
---|---|---|---|
Yes |
|||
No |
|||
No |
本来就是A题,其实没什么难的,比赛的时候就是看成平均数WA了..(上面应该讲的够清楚了)
当然可以直接将三个数排序(简单粗暴),也可以判断和中是否有至少一个成立。
#include <cstdio>
using namespace std;
int main()
{
int a, b, c;
scanf("%d%d%d", &a, &b, &c);
puts((a <= b && b <= c) || (c <= b && b <= a)? "Yes": "No");
return 0;
}
在的网格上,有恰好两个位置上各有一颗棋子,别的都是空位。
你可以从任意一个棋子开始,通过上下左右移动,前往另一个棋子的位置。
求至少要移动多少次?
先是一行,用空格隔开,然后有行,每行是一个长度为的字符串,-
表示这个位置是空位,o
表示这里有一颗棋子(详见样例)。
输出一行,即至少要移动的次数。
2 3
--o
o--
3
5 4
-o--
----
----
----
-o--
4
本题不需要,由于没有障碍物,直接找到两颗棋子,并输出(即的坐标差之和)即可。
#include <cstdio>
#include <vector>
using namespace std;
int main()
{
int h = 0, w = 0, x1 = -1, y1 = -1, x2 = -1, y2 = -1;
char c;
while((c = getchar()) != ' ')
h = (h << 3) + (h << 1) + (c ^ 48);
while((c = getchar()) != '\n')
w = (w << 3) + (w << 1) + (c ^ 48);
for(; h--; getchar())
for(int i=w; i--; )
if(getchar() == 'o')
if(x1 == -1) x1 = h, y1 = i;
else { x2 = h, y2 = i; break; }
printf("%d\n", x1 - x2 + (y1 > y2? y1 - y2: y2 - y1));
return 0;
}
我们有一个序列,初始为空。
请处理如下个操作:
1 x
:将插入至的末尾。2 x c
:从中删除个,如果不够删就直接删完。3
:求中最大值与最小值的差。
对于每个操作,输出中最大值与最小值的差。
典型STL练习题
本题可以用multiset
或map
解决,这里介绍使用map
的方法(仅限C++
使用)。
C++
中,我们需要用到std::map<int, int>
的如下方法:
mp[x]
或int& operator[](int&& key)
key
对应的value
的引用,如果之前没有用到过则创建并返回。map
中元素总数。iterator begin()
mp.begin()->first
可以获得mp
的最小元素iterator rbegin()
mp.rbegin()->first
可以获得mp
的最大元素size_type erase(const int& key)
key
以及对应的value
从map
中删除,返回删除的元素个数(或),返回值一般可以忽略。map
中元素总数。这时,每个查询都可转换为上述操作,详见代码。
#include <cstdio>
#include <map>
using namespace std;
int main()
{
int q;
scanf("%d", &q);
map<int, int> cnt;
while(q--)
{
int op;
scanf("%d", &op);
if(op == 3) printf("%d\n", cnt.rbegin()->first - cnt.begin()->first);
else if(op == 1)
{
int x;
scanf("%d", &x);
cnt[x] ++;
}
else if(op == 2)
{
int x, m;
scanf("%d%d", &x, &m);
if(cnt[x] > m) cnt[x] -= m;
else cnt.erase(x);
}
}
return 0;
}
输出到之间不是或的倍数的数之和。
输出答案。
根据容斥原理,到之间是或的倍数的数之和为:
的倍数之和的倍数之和同时为的倍数之和。
又因为同时为的倍数的数是(最小公倍数)的倍数,所以可转化为的倍数之和的倍数之和的倍数之和。
再设以内所有的倍数之和,
则答案为
总时间复杂度为求解的复杂度,即。
这里使用了另一种的求法,思路类似。
#include <cstdio>
using namespace std;
using LL = long long;
inline LL sum(const LL& x, const LL& n)
{
LL cnt = n / x;
return x * cnt * (cnt + 1LL) >> 1LL;
}
int main()
{
int n, a, b;
scanf("%d%d%d", &n, &a, &b);
LL x = b, y = a;
while(b ^= a ^= b ^= a %= b);
LL t = x / a * y; // t = lcm(a, b)
printf("%lld\n", sum(1, n) - sum(x, n) - sum(y, n) + sum(t, n));
return 0;
}
求符合如下条件的的个数,对取模:
输出符合条件的序列的个数,对取模。
很明显是(动态规划)的思路,仿照01背包的方式,我们设计如下状态:
状态转移方程也很简单,即:
那么,如果直接暴力循环计算,整个算法的时间复杂度是,显然不能通过。
但是注意到这里有个求和的操作,显然可以用前缀/后缀和优化,用的时间复杂度求出两个和,因此时间复杂度降到,可以通过。
最后一个坑,需要注意特判的情况,答案为。
本题到此结束。
特判使用快速幂,建议使用滚动表(又称数组重复利用)技巧,优化后实测:
#include <cstdio>
#define maxn 1002
#define maxm 5005
#define MOD 998244353
using namespace std;
using LL = long long;
int qpow(LL a, LL b)
{
LL ans = 1LL;
while(b > 0)
{
if(b & 1LL) ans = ans * a % MOD;
a = a * a % MOD, b >>= 1LL;
}
return ans;
}
inline void mod(int& x) { if(x >= MOD) x -= MOD; }
int dp[2][maxm];
int main()
{
int n, m, k;
scanf("%d%d%d", &n, &m, &k);
if(k == 0)
{
printf("%d\n", qpow(m, n));
return 0;
}
for(int i=1; i<=m; i++)
dp[0][i] = 1;
for(int i=1; i<n; i++)
{
int c = i & 1, p = c ^ 1, s = 0;
for(int j=k+1; j<=m; j++)
mod(s += dp[p][j]);
for(int j=1; j<=m; j++)
{
if(j > k) mod(s += dp[p][j - k]);
mod(dp[c][j] = s);
if(j + k <= m)
{
mod(s -= dp[p][j + k]);
if(s < 0) s += MOD;
}
}
}
int ans = 0, t = n & 1 ^ 1;
for(int i=1; i<=m; i++)
mod(ans += dp[t][i]);
printf("%d\n", ans);
return 0;
}